# coding: utf-8

"""
    Cisco Security Cloud Control API

    Use the documentation to explore the endpoints Security Cloud Control has to offer

    The version of the OpenAPI document: 1.5.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ConnectivityState(str, Enum):
    """
    The connectivity state of the device to CDO. A connectivity state that is not ONLINE can indicate either a problem with the device, or the communication pathways between the device and Security Cloud Control.
    """

    """
    allowed enum values
    """
    ONLINE = 'ONLINE'
    UNREACHABLE = 'UNREACHABLE'
    BAD_CREDENTIALS = 'BAD_CREDENTIALS'
    UNKNOWN = 'UNKNOWN'
    PENDING_SETUP = 'PENDING_SETUP'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ConnectivityState from a JSON string"""
        return cls(json.loads(json_str))


